"use strict";
const utils_1 = require("../metadata/utils");
const decorators_1 = require('../constants/decorators');
const decorator_type_1 = require('../enums/decorator-type');
/**
 * Ignores the property for an update in db from frontend or any external api source.
 * Params: An optional parameter, if no parameter supplied means the property will not be available in frontend at all.
 * if parameter Jsonignore.READ means the property will be available to frontend side but readonly mode. (can't altered by any external api in db)
 * @param params
 */
function jsonignore(params) {
    params = params || {};
    return function (target, propertyKey) {
        utils_1.MetaUtils.addMetaData(target, {
            decorator: decorators_1.Decorators.JSONIGNORE,
            decoratorType: decorator_type_1.DecoratorType.PROPERTY,
            params: params,
            propertyKey: propertyKey
        });
    };
}
exports.jsonignore = jsonignore;

//# sourceMappingURL=jsonignore.js.map
