"use strict";
const utils_1 = require("../metadata/utils");
const decorators_1 = require('../constants/decorators');
const decorator_type_1 = require('../enums/decorator-type');
const optimisticlock_type_1 = require("../enums/optimisticlock-type");
function OptimisticLocking(params) {
    params = params || {};
    return function (target, propertyKey) {
        let type = params && params["type"];
        switch (type) {
            case optimisticlock_type_1.OptimisticLockType.VERSION:
                utils_1.MetaUtils.addMetaData(target, {
                    decorator: decorators_1.Decorators.OPTIMISTICLOCK,
                    decoratorType: decorator_type_1.DecoratorType.PROPERTY,
                    params: params,
                    propertyKey: propertyKey
                });
                break;
        }
    };
}
exports.OptimisticLocking = OptimisticLocking;

//# sourceMappingURL=optimisticlocking.js.map
