"use strict";
const utils_1 = require("../metadata/utils");
const Utils = require("../utils");
const decorators_1 = require('../constants/decorators');
const decorator_type_1 = require('../enums/decorator-type');
//var domain = require('../../security/auth/domain');
const post_filter_service_1 = require('../services/post-filter-service');
function postfilter(params) {
    params = params || {};
    return function (target, propertyKey, descriptor) {
        utils_1.MetaUtils.addMetaData(target, {
            decorator: decorators_1.Decorators.POSTFILTER,
            decoratorType: decorator_type_1.DecoratorType.METHOD,
            params: params,
            propertyKey: propertyKey
        });
        var originalMethod = descriptor.value;
        descriptor.value = function () {
            var result = originalMethod.apply(this, arguments);
            if (Utils.isPromise(result)) {
                return result.then(ret => {
                    return post_filter_service_1.PostFilterService.postFilter(ret, params);
                });
            }
            else {
                return post_filter_service_1.PostFilterService.postFilter(result, params);
            }
        };
        return descriptor;
    };
}
exports.postfilter = postfilter;

//# sourceMappingURL=postfilter.js.map
