"use strict";
const dynamic_controller_1 = require('../dynamic/dynamic-controller');
const authcontroller_1 = require('../../security/auth/authcontroller');
const metadataController_1 = require('../api/metadataController');
const repositories_1 = require("../exports/repositories");
const decorators_1 = require('../constants/decorators');
class InitializeControllers {
    constructor() {
        this.initializeController();
    }
    initializeController() {
        for (var path in repositories_1.repositoryMap()) {
            let repo = repositories_1.repositoryMap()[path].repo;
            let meta = repo.getMetaData();
            if (meta && ((meta.params.exportType & decorators_1.ExportTypes.REST) == decorators_1.ExportTypes.REST)) {
                var controller = new dynamic_controller_1.DynamicController(repositories_1.repositoryMap()[path].fn, repo);
            }
        }
        var authController = new authcontroller_1.AuthController("/");
        var metadataController = new metadataController_1.MetadataController();
    }
}
exports.InitializeControllers = InitializeControllers;

//# sourceMappingURL=initialize-controllers.js.map
