"use strict";
const Enumerable = require('linq');
function GetAllActionFromPrototype(targetProtoType) {
    var properties = Object.getOwnPropertyNames(targetProtoType);
    var action = "do";
    var queryRegEx = new RegExp("^" + action, "i");
    var searchProperties = Enumerable.from(properties).where(p => {
        return queryRegEx.test(p);
    }).toArray();
    var namePropMap = [];
    var descs = [];
    Enumerable.from(searchProperties).forEach(x => {
        var desc = Object.getOwnPropertyDescriptor(targetProtoType, x);
        var arg = argumentNames(desc.value);
        namePropMap.push({ key: x, args: arg });
    });
    return namePropMap;
}
exports.GetAllActionFromPrototype = GetAllActionFromPrototype;
function argumentNames(fun) {
    var names = fun.toString().match(/^[\s\(]*[^(]*\(([^)]*)\)/)[1]
        .replace(/\/\/.*?[\r\n]|\/\*(?:.|[\r\n])*?\*\//g, '')
        .replace(/\s+/g, '').split(',');
    return names.length == 1 && !names[0] ? [] : names;
}

//# sourceMappingURL=actionUtils.js.map
