"use strict";
const di_1 = require('../di');
const utils_1 = require('../../core/metadata/utils');
const constants_1 = require('../../core/constants');
const enums_1 = require('../../core/enums');
function service(params) {
    params = params || {};
    params.singleton = true;
    return function (target) {
        di_1.Container.addService(target, params);
        params['target'] = target;
        utils_1.MetaUtils.addMetaData(target, {
            decorator: constants_1.Decorators.SERVICE,
            decoratorType: enums_1.DecoratorType.CLASS,
            params: params
        });
    };
}
exports.service = service;

//# sourceMappingURL=service.js.map
