﻿import {onetomany, manytoone, manytomany, transient} from '../core/decorators';
import {field, document} from '../mongoose/decorators';
import {Strict} from '../mongoose/enums';

export class BaseModel {
    @field({ primary: true, autogenerated: true })
    _id: any;

    @field()
    name: any;

    /*
       nodedata internal use for caching, use for findWhere case
   */
    @transient()
    __selectedFindWhere: boolean;

    /*
        nodedata internal use for caching, to marked as partial load for findMany (egar load case not load)
    */
    @transient()
    __partialLoaded: boolean;

    /*
        nodedata internal use for caching, to marked as fully load
    */
    @transient()
    __FullyLoaded: boolean;
}

export default BaseModel;