"use strict";
const utils_1 = require("../../core/metadata/utils");
const constants_1 = require('../../core/constants');
const decorator_type_1 = require('../../core/enums/decorator-type');
var _dcoumentDecoratorCache = {};
function document(params) {
    params = params || {};
    return function (target) {
        console.log("Document: " + params.name);
        if (_dcoumentDecoratorCache[params.name]) {
            return;
        }
        _dcoumentDecoratorCache[params.name] = params;
        // add metadata to prototype
        utils_1.MetaUtils.addMetaData((target.prototype || target), {
            decorator: constants_1.Decorators.DOCUMENT,
            decoratorType: decorator_type_1.DecoratorType.CLASS,
            modelType: decorator_type_1.DecoratorType.MODEL,
            params: params
        });
    };
}
exports.document = document;

//# sourceMappingURL=document.js.map
