"use strict";
var mongoosastic = require("mongoosastic");
var elasticsearch = require("elasticsearch");
const config_1 = require("../config");
/**
 * ElastticSearchUtils
 */
class ElastticSearchUtils {
    constructor() {
        if (config_1.Config.ApplyElasticSearch) {
            this.esClient = new elasticsearch.Client({ host: config_1.Config.ElasticSearchConnection });
        }
    }
    insertMongoosasticToSchema(schema) {
        if (config_1.Config.ApplyElasticSearch) {
            schema.plugin(mongoosastic, {
                esClient: this.esClient
            });
        }
    }
    registerToMongoosastic(mongooseModel) {
        // This will be called only in the case if the mongoosastic plugin was attached to the mongoose model.
        if (config_1.Config.ApplyElasticSearch && mongooseModel.createMapping) {
            mongooseModel.createMapping((err, mapping) => {
                if (err) {
                    console.error(err);
                }
                else {
                    console.log(mapping);
                }
            });
        }
    }
}
exports.searchUtils = new ElastticSearchUtils();

//# sourceMappingURL=elasticSearchUtils.js.map
