﻿import { field, document } from '../../mongoose/decorators';
import { Types } from 'mongoose';
import { Strict } from '../../mongoose/enums';
import {workerParamsDto} from "../../core/decorators/interfaces/workerParamsDto";
console.log('initializing ProcessControlModel');
@document({ name: 'processControl', strict: Strict.false })
export class ProcessControlModel {
    @field({ primary: true, autogenerated: true })
    _id: Types.ObjectId;

    @field()
    processEntityType: string;

    @field()
    processEntityId: string;

    @field()
    processEntityAction: string;

    @field()
    previousStatus: string;

    @field()
    status: string;

    @field()
    args: any;

    @field()
    erroMessage: string;

    @field({ itemType: workerParamsDto })
    workerDetails: workerParamsDto;

    @field()
    processId: number;

    @field()
    serviceName: string;

    @field()
    serviceMethodName: string;

    @field()
    serviceMethodArgs: Array<string | number>;

    @field()
    responseData: any;
}
export default ProcessControlModel;